﻿namespace NPin.Framework.AspNetCore.Authentication.OAuth.QQ;

/// <summary>
/// Default values for QQ authentication.
/// </summary>
public class QQAuthenticationDefaults
{
    /// <summary>
    /// Default value for <see cref="AuthenticationScheme.Name"/>.
    /// </summary>
    public const string AuthenticationScheme = "QQ";

    /// <summary>
    /// Default value for <see cref="AuthenticationScheme.DisplayName"/>.
    /// </summary>
    public static readonly string DisplayName = "QQ";

    /// <summary>
    /// Default value for <see cref="AuthenticationSchemeOptions.ClaimsIssuer"/>.
    /// </summary>
    public static readonly string Issuer = "QQ";

    /// <summary>
    /// Default value for <see cref="RemoteAuthenticationOptions.CallbackPath"/>.
    /// </summary>
    public static readonly string CallbackPath = "/signin-qq";

    /// <summary>
    /// Default value for <see cref="OAuthOptions.AuthorizationEndpoint"/>.
    /// </summary>
    public static readonly string AuthorizationEndpoint = "https://graph.qq.com/oauth2.0/authorize";

    /// <summary>
    /// Default value for <see cref="OAuthOptions.TokenEndpoint"/>.
    /// </summary>
    public static readonly string TokenEndpoint = "https://graph.qq.com/oauth2.0/token";

    /// <summary>
    /// Default value for <see cref="QQAuthenticationOptions.UserIdentificationEndpoint"/>.
    /// </summary>
    public static readonly string UserIdentificationEndpoint = "https://graph.qq.com/oauth2.0/me";

    /// <summary>
    /// Default value for <see cref="OAuthOptions.UserInformationEndpoint"/>.
    /// </summary>
    public static readonly string UserInformationEndpoint = "https://graph.qq.com/user/get_user_info";
}