﻿namespace NPin.Framework.Upms.Domain.Shared.Options;

/// <summary>
/// Upms模块的总体配置
/// </summary>
public class UpmsOptions
{
    /// <summary>
    /// 超级管理员默认密码
    /// </summary>
    public string AdminPassword { get; set; } = "a123456";

    /// <summary>
    /// 租户超级管理员默认密码
    /// </summary>
    public string TenantAdminPassword { get; set; } = "a123456";

    /// <summary>
    /// 是否开启登录图形验证码
    /// </summary>
    public bool EnableCaptcha { get; set; } = false;

    /// <summary>
    /// 是否开启注册功能
    /// </summary>
    public bool EnableRegister { get; set; } = false;

    /// <summary>
    /// 是否开启数据库自动o备份功能
    /// </summary>
    public bool EnableDataBaseBackup { get; set; } = false;
}